Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## BEA WebLogic Server 9.0 API Reference

## weblogic.apache.xml.serialize
Class XMLSerializer

    java.lang.Object
      weblogic.apache.xml.serialize.BaseMarkupSerializer
          weblogic.apache.xml.serialize.XMLSerializer

All Implemented Interfaces:
  ContentHandler, DeclHandler, DocumentHandler, DOMSerializer, DTDHandler, LexicalHandler, Serializer

public class XMLSerializer
extends BaseMarkupSerializer

Implements an XML serializer supporting both DOM and SAX pretty serializing. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. SAX serializing is done by firing SAX events and using the serializer as a document handler. DOM serializing is done by calling `BaseMarkupSerializer.serialize(Document)` or by using DOM Level 3 `DOMWriter` and serializing with `DOMWriter.writeNode(java.io.OutputStream, org.w3c.dom.Node)`, `DOMWriter.writeToString(org.w3c.dom.Node)`.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

See Also:
  `Serializer`

Field Summary
`protected static boolean` | `DEBUG`
`protected boolean` | `fDOML1`
`protected NamespaceSupport` | `fLocalNSBinder` stores all namespace bindings on the current element
`protected int` | `fNamespaceCounter`
`protected boolean` | `fNamespaces` Controls whether namespace fixup should be performed during the serialization.
`protected NamespaceSupport` | `fNSBinder` stores namespaces in scope
`protected SymbolTable` | `fSymbolTable` symbol table for serialization
`protected static String` | `PREFIX`

Fields inherited from class weblogic.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _encodingInfo, _format, _indenting, _prefixes, _printer, _started, fDOMError, fDOMErrorHandler, fDOMFilter, fFeatures, fStrBuffer`

Constructor Summary
`XMLSerializer()` Constructs a new serializer.
`XMLSerializer(OutputFormat format)` Constructs a new serializer.
`XMLSerializer(OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`XMLSerializer(Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` | `endElement(String tagName)`
`void` | `endElement(String namespaceURI, String localName, String rawName)`
`void` | `endElementIO(String namespaceURI, String localName, String rawName)`
`protected String` | `getEntityRef(int ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected void` | `printEscaped(String source)` Escapes a string so it may be printed as text content or attribute value.
`protected void` | `printText(char[] chars, int start, int length, boolean preserveSpace, boolean unescaped)` Called to print additional text with whitespace handling.
`protected void` | `printText(String text, boolean preserveSpace, boolean unescaped)`
`protected void` | `printXMLChar(int ch)`
`boolean` | `reset()`
`protected void` | `serializeElement(Element elem)` Called to serialize a DOM element.
`void` | `setNamespaces(boolean namespaces)` Deprecated. -- functionality could be removed
`void` | `setOutputFormat(OutputFormat format)`
`protected void` | `startDocument(String rootTagName)` Called to serialize the document's DOCTYPE by the root element.
`void` | `startElement(String tagName, AttributeList attrs)`
`void` | `startElement(String namespaceURI, String localName, String rawName, Attributes attrs)`

Methods inherited from class weblogic.apache.xml.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, characters, characters, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, fatalError, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, modifyDOMError, notationDecl, prepare, printCDATAText, printDoctypeURL, printEscaped, processingInstruction, processingInstructionIO, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, surrogates, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEBUG

    protected static final boolean DEBUG

See Also:
  Constant Field Values

### fDOML1

    protected boolean fDOML1

### fLocalNSBinder

    protected NamespaceSupport fLocalNSBinder

  stores all namespace bindings on the current element

### fNamespaceCounter

    protected int fNamespaceCounter

### fNamespaces

    protected boolean fNamespaces

  Controls whether namespace fixup should be performed during the serialization. NOTE: if this field is set to true the following fields need to be initialized: fNSBinder, fLocalNSBinder, fSymbolTable, XMLSymbols.EMPTY_STRING, fXmlSymbol, fXmlnsSymbol, fNamespaceCounter.

### fNSBinder

    protected NamespaceSupport fNSBinder

  stores namespaces in scope

### fSymbolTable

    protected SymbolTable fSymbolTable

  symbol table for serialization

### PREFIX

    protected static final String PREFIX

See Also:
  Constant Field Values

Constructor Detail

### XMLSerializer

    public XMLSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XMLSerializer

    public XMLSerializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### XMLSerializer

    public XMLSerializer(OutputStream output,
                         OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.

### XMLSerializer

    public XMLSerializer(Writer writer,
                         OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.

Method Detail

### endElement

    public void endElement(String tagName)
                    throws SAXException

  Throws:
    `SAXException`

### endElement

    public void endElement(String namespaceURI,
                           String localName,
                           String rawName)
                    throws SAXException

  Throws:
    `SAXException`

### endElementIO

    public void endElementIO(String namespaceURI,
                             String localName,
                             String rawName)
                      throws IOException

  Throws:
    `IOException`

### getEntityRef

    protected String getEntityRef(int ch)

  Description copied from class: `BaseMarkupSerializer`
  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.

  Specified by:
    `getEntityRef` in class `BaseMarkupSerializer`
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### printEscaped

    protected void printEscaped(String source)
                         throws IOException

  Description copied from class: `BaseMarkupSerializer`
  Escapes a string so it may be printed as text content or attribute value. Non printable characters are escaped using character references. Where the format specifies a deault entity reference, that reference is used (e.g. `&lt;`).

  Overrides:
    `printEscaped` in class `BaseMarkupSerializer`
  Parameters:
    `source` - The string to escape
  Throws:
    `IOException`

### printText

    protected void printText(char[] chars,
                             int start,
                             int length,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws IOException

  Description copied from class: `BaseMarkupSerializer`
  Called to print additional text with whitespace handling. If spaces are preserved, the text is printed as if by calling `BaseMarkupSerializer.printText(String,boolean,boolean)` with a call to `Printer.breakLine()` for each new line. If spaces are not preserved, the text is broken at space boundaries if longer than the line width; Multiple spaces are printed as such, but spaces at beginning of line are removed.

  Overrides:
    `printText` in class `BaseMarkupSerializer`
  Parameters:
    `preserveSpace` - Space preserving flag
    `unescaped` - Print unescaped
  Throws:
    `IOException`

### printText

    protected void printText(String text,
                             boolean preserveSpace,
                             boolean unescaped)
                      throws IOException

  Overrides:
    `printText` in class `BaseMarkupSerializer`
  Throws:
    `IOException`

### printXMLChar

    protected final void printXMLChar(int ch)
                               throws IOException

  Throws:
    `IOException`

### reset

    public boolean reset()

  Overrides:
    `reset` in class `BaseMarkupSerializer`

### serializeElement

    protected void serializeElement(Element elem)
                             throws IOException

  Called to serialize a DOM element. Equivalent to calling `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`, `endElement(java.lang.String, java.lang.String, java.lang.String)` and serializing everything inbetween, but better optimized.

  Specified by:
    `serializeElement` in class `BaseMarkupSerializer`
  Parameters:
    `elem` - The element to serialize
  Throws:
    `IOException` - An I/O exception occured while serializing

### setNamespaces

    public void setNamespaces(boolean namespaces)

  Deprecated. -- functionality could be removed

  This methods turns on namespace fixup algorithm during DOM serialization.

  Parameters:
    `namespaces` -
  See Also:
    `DOMWriter`

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Description copied from interface: `Serializer`
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.

  Specified by:
    `setOutputFormat` in interface `Serializer`
  Overrides:
    `setOutputFormat` in class `BaseMarkupSerializer`

### startDocument

    protected void startDocument(String rootTagName)
                          throws IOException

  Called to serialize the document's DOCTYPE by the root element. The document type declaration must name the root element, but the root element is only known when that element is serialized, and not at the start of the document.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

  Throws:
    `IOException`

### startElement

    public void startElement(String tagName,
                             AttributeList attrs)
                      throws SAXException

  Throws:
    `SAXException`

### startElement

    public void startElement(String namespaceURI,
                             String localName,
                             String rawName,
                             Attributes attrs)
                      throws SAXException

  Throws:
    `SAXException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs90 Copyright 2005 BEA Systems Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD